var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { LitElement, html } from 'lit';
import { customElement, property, state } from 'lit/decorators.js';
import { Traveler, Route } from 'travelerjs';
const router = new Traveler();
let LitRouter = class LitRouter extends LitElement {
    constructor() {
        super(...arguments);
        this.routes = [];
        this.content = html ``;
        this.params = '';
    }
    render() {
        return this.content;
    }
    firstUpdated() {
        this.routes.forEach(r => {
            router.register(new Route(r.path, params => {
                this.params = params;
                this.content = r.content;
            }));
        });
        router.listen();
    }
};
__decorate([
    property()
], LitRouter.prototype, "routes", void 0);
__decorate([
    state()
], LitRouter.prototype, "content", void 0);
__decorate([
    state()
], LitRouter.prototype, "params", void 0);
LitRouter = __decorate([
    customElement('lit-router')
], LitRouter);
export { LitRouter };
let RouterLink = class RouterLink extends LitElement {
    constructor() {
        super(...arguments);
        this.to = '#';
        this.class = '';
        this['anchor-id'] = '';
    }
    render() {
        return html `
            <a class=${this.class} @click=${this.go} href='' id=${this['anchor-id']}>
                <slot></slot>
            </a>
        `;
    }
    go(ev) {
        ev.preventDefault();
        router.go(this.to);
    }
};
__decorate([
    property()
], RouterLink.prototype, "to", void 0);
__decorate([
    property()
], RouterLink.prototype, "class", void 0);
__decorate([
    property()
], RouterLink.prototype, "anchor-id", void 0);
RouterLink = __decorate([
    customElement('router-link')
], RouterLink);
export { RouterLink };
export function getParams() {
    const paths = location.pathname.split('/');
    return paths[paths.length - 1];
}
